-------------------------------------------------------------------------- 
-- Color space converter support functions								    
--------------------------------------------------------------------------   

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;  

LIBRARY work;
USE work.genxlib_utils.ALL;

PACKAGE color_space_pkg IS
  function RGB2YCrCb_LATENCY(FAMILY_HAS_MAC:integer; FABRIC_ADDS, HAS_CLIP, HAS_CLAMP: integer) return integer;
  function YCrCb2RGB_LATENCY(FAMILY_HAS_MAC:integer; FABRIC_ADDS, HAS_CLIP, HAS_CLAMP: integer) return integer;
END color_space_pkg;

PACKAGE BODY color_space_pkg IS

  function RGB2YCrCb_LATENCY(FAMILY_HAS_MAC:integer; FABRIC_ADDS, HAS_CLIP, HAS_CLAMP: integer) return integer is
  begin
    -- data has to pass through 4 adders + 2 mults + 1 rounder(essentially another adder) + max + min 
    return( 3*ADD_DELAY(FAMILY_HAS_MAC,FABRIC_ADDS)+2*MULT_ADD_DELAY(FAMILY_HAS_MAC,FABRIC_ADDS)+HAS_CLIP+HAS_CLAMP); 
  end RGB2YCrCb_LATENCY;

  function YCrCb2RGB_LATENCY(FAMILY_HAS_MAC:integer; FABRIC_ADDS, HAS_CLIP, HAS_CLAMP: integer) return integer is
  begin
    return( MULT_ADD_DELAY(FAMILY_HAS_MAC,FABRIC_ADDS)+1+ADD_DELAY(FAMILY_HAS_MAC,FABRIC_ADDS)+HAS_CLIP+HAS_CLAMP); -- multiplier + rounder + y_adder + max + min
  end YCrCb2RGB_LATENCY;
    
END color_space_pkg;

